/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg/Parameter.msg
 *
 */


#ifndef SANDIA_HAND_MSGS_MESSAGE_PARAMETER_H
#define SANDIA_HAND_MSGS_MESSAGE_PARAMETER_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sandia_hand_msgs
{
template <class ContainerAllocator>
struct Parameter_
{
  typedef Parameter_<ContainerAllocator> Type;

  Parameter_()
    : name()
    , val_type(0)
    , i_val(0)
    , f_val(0.0)  {
    }
  Parameter_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , val_type(0)
    , i_val(0)
    , f_val(0.0)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef int8_t _val_type_type;
  _val_type_type val_type;

   typedef uint32_t _i_val_type;
  _i_val_type i_val;

   typedef float _f_val_type;
  _f_val_type f_val;


    enum { INTEGER = 1 };
     enum { FLOAT = 2 };
 

  typedef boost::shared_ptr< ::sandia_hand_msgs::Parameter_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sandia_hand_msgs::Parameter_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Parameter_

typedef ::sandia_hand_msgs::Parameter_<std::allocator<void> > Parameter;

typedef boost::shared_ptr< ::sandia_hand_msgs::Parameter > ParameterPtr;
typedef boost::shared_ptr< ::sandia_hand_msgs::Parameter const> ParameterConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sandia_hand_msgs::Parameter_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sandia_hand_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sandia_hand_msgs': ['/tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::Parameter_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::Parameter_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::Parameter_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
{
  static const char* value()
  {
    return "57415258934843cb3facecb3fd658b64";
  }

  static const char* value(const ::sandia_hand_msgs::Parameter_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x57415258934843cbULL;
  static const uint64_t static_value2 = 0x3facecb3fd658b64ULL;
};

template<class ContainerAllocator>
struct DataType< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sandia_hand_msgs/Parameter";
  }

  static const char* value(const ::sandia_hand_msgs::Parameter_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string  name\n\
byte    INTEGER=1\n\
byte    FLOAT=2\n\
byte    val_type\n\
uint32  i_val\n\
float32 f_val\n\
";
  }

  static const char* value(const ::sandia_hand_msgs::Parameter_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.val_type);
      stream.next(m.i_val);
      stream.next(m.f_val);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Parameter_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sandia_hand_msgs::Parameter_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sandia_hand_msgs::Parameter_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "val_type: ";
    Printer<int8_t>::stream(s, indent + "  ", v.val_type);
    s << indent << "i_val: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.i_val);
    s << indent << "f_val: ";
    Printer<float>::stream(s, indent + "  ", v.f_val);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SANDIA_HAND_MSGS_MESSAGE_PARAMETER_H
