/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg/RawFingerCommands.msg
 *
 */


#ifndef SANDIA_HAND_MSGS_MESSAGE_RAWFINGERCOMMANDS_H
#define SANDIA_HAND_MSGS_MESSAGE_RAWFINGERCOMMANDS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sandia_hand_msgs
{
template <class ContainerAllocator>
struct RawFingerCommands_
{
  typedef RawFingerCommands_<ContainerAllocator> Type;

  RawFingerCommands_()
    : motor_targets()  {
      motor_targets.assign(0);
  }
  RawFingerCommands_(const ContainerAllocator& _alloc)
    : motor_targets()  {
      motor_targets.assign(0);
  }



   typedef boost::array<int16_t, 3>  _motor_targets_type;
  _motor_targets_type motor_targets;




  typedef boost::shared_ptr< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RawFingerCommands_

typedef ::sandia_hand_msgs::RawFingerCommands_<std::allocator<void> > RawFingerCommands;

typedef boost::shared_ptr< ::sandia_hand_msgs::RawFingerCommands > RawFingerCommandsPtr;
typedef boost::shared_ptr< ::sandia_hand_msgs::RawFingerCommands const> RawFingerCommandsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sandia_hand_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sandia_hand_msgs': ['/tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "62e121b7d21d200f20a78585e63fdbe0";
  }

  static const char* value(const ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x62e121b7d21d200fULL;
  static const uint64_t static_value2 = 0x20a78585e63fdbe0ULL;
};

template<class ContainerAllocator>
struct DataType< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sandia_hand_msgs/RawFingerCommands";
  }

  static const char* value(const ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int16[3] motor_targets\n\
";
  }

  static const char* value(const ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.motor_targets);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RawFingerCommands_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sandia_hand_msgs::RawFingerCommands_<ContainerAllocator>& v)
  {
    s << indent << "motor_targets[]" << std::endl;
    for (size_t i = 0; i < v.motor_targets.size(); ++i)
    {
      s << indent << "  motor_targets[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.motor_targets[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SANDIA_HAND_MSGS_MESSAGE_RAWFINGERCOMMANDS_H
