/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg/RawMoboState.msg
 *
 */


#ifndef SANDIA_HAND_MSGS_MESSAGE_RAWMOBOSTATE_H
#define SANDIA_HAND_MSGS_MESSAGE_RAWMOBOSTATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sandia_hand_msgs
{
template <class ContainerAllocator>
struct RawMoboState_
{
  typedef RawMoboState_<ContainerAllocator> Type;

  RawMoboState_()
    : mobo_time(0)
    , finger_currents()
    , logic_currents()
    , mobo_temp()
    , mobo_max_effort(0)  {
      finger_currents.assign(0.0);

      logic_currents.assign(0.0);

      mobo_temp.assign(0);
  }
  RawMoboState_(const ContainerAllocator& _alloc)
    : mobo_time(0)
    , finger_currents()
    , logic_currents()
    , mobo_temp()
    , mobo_max_effort(0)  {
      finger_currents.assign(0.0);

      logic_currents.assign(0.0);

      mobo_temp.assign(0);
  }



   typedef uint32_t _mobo_time_type;
  _mobo_time_type mobo_time;

   typedef boost::array<float, 4>  _finger_currents_type;
  _finger_currents_type finger_currents;

   typedef boost::array<float, 3>  _logic_currents_type;
  _logic_currents_type logic_currents;

   typedef boost::array<uint16_t, 3>  _mobo_temp_type;
  _mobo_temp_type mobo_temp;

   typedef uint8_t _mobo_max_effort_type;
  _mobo_max_effort_type mobo_max_effort;




  typedef boost::shared_ptr< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RawMoboState_

typedef ::sandia_hand_msgs::RawMoboState_<std::allocator<void> > RawMoboState;

typedef boost::shared_ptr< ::sandia_hand_msgs::RawMoboState > RawMoboStatePtr;
typedef boost::shared_ptr< ::sandia_hand_msgs::RawMoboState const> RawMoboStateConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sandia_hand_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sandia_hand_msgs': ['/tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "4e7e33569ea3b39428acbd57e6ef85b5";
  }

  static const char* value(const ::sandia_hand_msgs::RawMoboState_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x4e7e33569ea3b394ULL;
  static const uint64_t static_value2 = 0x28acbd57e6ef85b5ULL;
};

template<class ContainerAllocator>
struct DataType< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sandia_hand_msgs/RawMoboState";
  }

  static const char* value(const ::sandia_hand_msgs::RawMoboState_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint32 mobo_time\n\
float32[4] finger_currents\n\
float32[3] logic_currents\n\
uint16[3] mobo_temp\n\
uint8 mobo_max_effort\n\
";
  }

  static const char* value(const ::sandia_hand_msgs::RawMoboState_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.mobo_time);
      stream.next(m.finger_currents);
      stream.next(m.logic_currents);
      stream.next(m.mobo_temp);
      stream.next(m.mobo_max_effort);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RawMoboState_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sandia_hand_msgs::RawMoboState_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sandia_hand_msgs::RawMoboState_<ContainerAllocator>& v)
  {
    s << indent << "mobo_time: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.mobo_time);
    s << indent << "finger_currents[]" << std::endl;
    for (size_t i = 0; i < v.finger_currents.size(); ++i)
    {
      s << indent << "  finger_currents[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.finger_currents[i]);
    }
    s << indent << "logic_currents[]" << std::endl;
    for (size_t i = 0; i < v.logic_currents.size(); ++i)
    {
      s << indent << "  logic_currents[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.logic_currents[i]);
    }
    s << indent << "mobo_temp[]" << std::endl;
    for (size_t i = 0; i < v.mobo_temp.size(); ++i)
    {
      s << indent << "  mobo_temp[" << i << "]: ";
      Printer<uint16_t>::stream(s, indent + "  ", v.mobo_temp[i]);
    }
    s << indent << "mobo_max_effort: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.mobo_max_effort);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SANDIA_HAND_MSGS_MESSAGE_RAWMOBOSTATE_H
