/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg/SimpleGrasp.msg
 *
 */


#ifndef SANDIA_HAND_MSGS_MESSAGE_SIMPLEGRASP_H
#define SANDIA_HAND_MSGS_MESSAGE_SIMPLEGRASP_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sandia_hand_msgs
{
template <class ContainerAllocator>
struct SimpleGrasp_
{
  typedef SimpleGrasp_<ContainerAllocator> Type;

  SimpleGrasp_()
    : name()
    , closed_amount(0.0)  {
    }
  SimpleGrasp_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , closed_amount(0.0)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef double _closed_amount_type;
  _closed_amount_type closed_amount;




  typedef boost::shared_ptr< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SimpleGrasp_

typedef ::sandia_hand_msgs::SimpleGrasp_<std::allocator<void> > SimpleGrasp;

typedef boost::shared_ptr< ::sandia_hand_msgs::SimpleGrasp > SimpleGraspPtr;
typedef boost::shared_ptr< ::sandia_hand_msgs::SimpleGrasp const> SimpleGraspConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sandia_hand_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sandia_hand_msgs': ['/tmp/buildd/sandia-hand-prerelease-5.3.0/ros/sandia_hand_msgs/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "95873588e5f0e32a373b23f95e571087";
  }

  static const char* value(const ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x95873588e5f0e32aULL;
  static const uint64_t static_value2 = 0x373b23f95e571087ULL;
};

template<class ContainerAllocator>
struct DataType< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sandia_hand_msgs/SimpleGrasp";
  }

  static const char* value(const ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string  name\n\
float64 closed_amount  \n\
# closed_amount = 0 means fully open\n\
# closed_amount = 1 means fully closed\n\
";
  }

  static const char* value(const ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.closed_amount);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SimpleGrasp_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sandia_hand_msgs::SimpleGrasp_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "closed_amount: ";
    Printer<double>::stream(s, indent + "  ", v.closed_amount);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SANDIA_HAND_MSGS_MESSAGE_SIMPLEGRASP_H
